unit zglGUI;

interface

{  ******************           ZENGL GUI INTERFACE MODULE           ******************

       GUI-   ZenglEngine
    : Dj_smart (icq: 9804336)
    : 1.1
              :)

  **************************              **************************

    : guiInit('    -');
                   guiInit('data/gui');

         ,    .
        ,         .

    guiProcess;
                
      (,     Timer_Create)
       
    guiDraw;
              
    guiFocus;
              
    guiDrawMouse;
       

    

      1.   ,   :)
      2.            
        ( guiProcess  guiRefreshMouse)
      3. guiVolume -      ,  

  **************************                  **************************

  ***  ***
    :  
    :    guiDrawForm
    : X,Y ()
               W,H (),
               Text ( ),
               trans ()
    : guiDrawForm('1',X,Y,W,H)

  ***  ***
    :  
    :    guiDrawMemoBorder
    : X,Y ()
               W,H (),
               Text ( ),
               Transparenty ()
    : guiDrawMemoBorder(X,Y,W,H);

  ***    ***
    :      
    :    guiDrawTabs
    : X,Y ()
               W,H (),
               Text ( ),
               Tabs ( ,   "|",  "|"  )
               SelId -  ,   
    : guiDrawTabs(X,Y,W,H,'Tabs1','Tab1|Tab2|Tab3|',b); // b - var b:integer;

  ***  ***
    :  
    :    guiDrawText
    : X,Y ()
               Text ( ),
               doCenter ( ),
               doHover (  )
               trans ()
    : guiDrawText('1',X,Y)

  ***  ***
    :  ,   
    :    guiDrawButton
    : X,Y ()
               W ()
               Text ( )
               doCenter -  
    : if guiDrawButton('Text',X,Y,W)=button_button_click then ...   
      button_none -   
      button_hover -   
      button_click -   

  *** - ***
    :   
    :    guiDrawProgressBar(X,Y,W,Coef:single);
    : X,Y ()
               W ()
               Coef (  - 0.0 - , 1.0 - )
    : guiDrawProgressBar(X,Y,W,0.5)

  ***   ***
    :  -     
    :    guiDrawCheckBox
    : X,Y (),
               doVal -  ,  
    : guiDrawCheckBox('Text',X,Y,b); // b - var b:boolean;

  *** - ***
    :   -,      
    :    guiDrawRadioButtons
    : X,Y (),
               Text (    "|".    |),
               doVal -  ,   
    : guiDrawCheckBox('Value1|Value2|Value3|',X,Y,b); // b - var b:integer;

  **************************                   **************************

  ***   ***
    :   
    :     TMyEdit   .
    : X,Y (),
               W (),
               Text ( )
               TextType ( )
                 tt_normal -  
                 tt_numbers -  
               Hint ( )
    : guiDrawEdit(@_); - 
                   guiInitEdit(@_,X,Y,Width:integer;[Text,Hint:String;TextType:byte]); - 
    Events: OnChange -   . // Edit1.OnChange:=@OnChangeEnent;

   ***   ***
    :   
    :     TMyComboBox   .
    : X,Y (),
               W (),
               ElementsTexture -  (PTexture),      .
                     ,   1 -  1.
                   Tex_SetFramesSize,   16x16, 
                      1616.
               Values  ,   SetLength
               SelId -  .     Values[SelId].
                  .   0
    : guiDrawComboBox(@_); - 
                   guiInitComboBox(@_,X,Y,Width:integer); - 
    Events: OnChange -   

    ***   ***
    :   
    :     TMyPopup   .
    : guiShowPopup(X,Y,@_) -   
                   gupInitPopup(@_,'|||',@_); - ,
                      _ - ,      
                     procedure _(selected:integer);
                     begin
                       case selected of
                         0: ; // 
                         1: ; // 
                         2: ; // 
                         3: ; // 
                       end;
                     end;
                      ,   
                     _.Items[3].Active:=false; //  . ""
    Events: OnSelect(selected:integer) -   

    *** Track-bar ***
    :  
    :     TMyTrakBar   .
    : X,Y (),
               W (),
               Max ( , Min - 0)
               Value -  ,     integer:
                 trVolume.Value:=@GameVolume; // var GameVolume:integer;
    : guiDrawTrackBar(@_);
    Events: OnChange -   
  }

uses Windows, zglHeader;

const
  formYOffset = 2; formXOffset=2;
  textColor = $00FFFFFF; textHoverColor = $0054F68F; textScale = 0.6; textXOffset = 2; textYOffset = 4;

  //      Thefont.tga
  symbolWidth = 7; symbolHeight = 10;

  {***  (X,Y)   (Width,Height)    Gui.tga
       /.   
     100  buttonWidth=32 ,     - 64 px,
      32  ()  1 (32-)   36  (100-32*2)
         ***}
    buttonX = 0; buttonY = 0; buttonWidth = 32; buttonHeight = 24; // 
    cboxX = 32; cboxY = 0; cboxWidth = 16; cboxHeight = 16; // 
    rdX = 48; rdY = 0; rdWidth = 16; rdHeight = 16; // -
    frmX = 64; frmY = 0; frmWidth = 24; frmHeight = 24; // 
    tblX = 0; tblY = 89; tblWidth = 16; tblHeight = 16; // 
    tblHX = 32; tblHY = 89; tblHWidth = 1; tblHHeight = 14; //    
    editX = 64; editY = 48; editWidth = 3; editHeight = 17; //  
    editselX = 168; editselY = 34; editselWidth = 2; editselHeight = 13; //    
    comboX = 71; comboY = 48; comboWidth = 3; comboSelWidth = 17; comboHeight = 17; //  
    {***         ***}
      comboMoveX = 144; comboMoveY = 0; comboMoveWidth = 12; comboMoveHeight = 12; comboMovePHeight = 25;
      comboSize = 16;
      comboLineX = 144; comboLineY = 49; comboLineWidth = 12; comboLineHeight = 4;
    {*** ***}
    memoX = 112; memoY = 0; memoWidth = 16; memoHeight = 16; //  
    selX = 109; selY = 48; selWidth = 3; selHeight = 17; //   
    pbX = 0; pbY = 72; pbWidth = 3; pbHeight = 17; // 
    tabX = 72; tabY = 65; tabWidth = 32; tabHeight = 24; // 
    trackX = 168; trackY = 0; trackWidth=15; trackHeight = 17; // -


    elX = 112; elY = 32; elWidth = 32; elHeight = 16; //   
    layX = 8; layY = 72; layWidth = 16; layHeight = 10; //   - 
  {*** ***}

  //   
  button_none=0; //   
  button_hover=1; //   
  button_click=2; //   

  //  
  tt_normal=0;
  tt_numbers=1;

  //  
  ft_none=0;
  ft_edit=1;
  ft_combobox=2;
  ft_comboboxmove=3;
  ft_trackbar=4;
  ft_popup=5;
  ft_tablemove=6;

  // alignment

  align_left = 0;
  align_center = 1;
  align_right = 2;

  // header types

  ht_string = 0;
  ht_checkbox = 1;

type

  PMyEdit=^TMyEdit;
  TMyEdit=record
    X,Y,W:integer;
    Text,Hint:string;
    TTNumbersValue:PInteger;
    TextType:byte;
    OnChange:procedure;
    Offset,SelectStart,SelectEnd:Integer;
    LeftText,RightText:string;
  end;
  PMyComboBox=^TMyComboBox;
  TMyComboBox=record
    X,Y,W:integer;
    prOffset,Offset:Integer;
    ElementsTexture:zglPTexture;
    Values:array of String;
    SelId:Integer;
    OnChange:procedure;
  end;
  PMyTable=^TMyTable;
  TTableHeader=record
    Text:string;
    Width:single;
    Align:byte;
    Htype:Byte;
  end;
  TMyTable=record
    X,Y,W,H:integer;
    prOffset,Offset:Integer;
    Headers:array of TTableHeader;
    Size:TPoint;
    Values:array of array of String;
    SelId:Integer;
  end;
  PMyTrakBar=^TMyTrakBar;
  TMyTrakBar=record
    X,Y,W,Max:integer;
    Value:PInteger;
    prOffset,LastValue:Integer;
    OnChange:procedure;
  end;
  TMyAction=record
    Text:string;
    Active:Boolean;
  end;
  PMyPopup=^TMyPopup;
  TMyPopup=record
    X,Y,Width:Integer;
    Items:array of TMyAction;
    OnSelect:procedure(selected:integer);
  end;

var
  txtMainTex, txtFont, txtCursor: zglPTexture;
  sndButtonClick : zglPSound;
  RbState,LbState:Boolean;
  R:zglTRect;
  EditActionsPopup:TMyPopup;
  ClickOnEdit:Boolean;
  MoveOffset,EditSelectStart:Integer;
  guiVolume:Integer=100;
  RuLayout:Boolean=True;
  selVal:Integer;
  VHnd:THandle;
  Focus:record
    FocusType:Byte;
    asEdit:PMyEdit;
    asComboBox:PMyComboBox;
    asTrackBar:PMyTrakBar;
    asPopup:PMyPopup;
    asTable:PMyTable;
  end;

  procedure guiDrawForm(Text:string; X,Y,W,H:single;trans:Byte=255);
  procedure guiDrawText(Text:string; X,Y:single; Align:byte=align_left; doHover:Boolean=false;trans:byte=255; tColor:Integer = textColor);
  function guiDrawButton(Text:string; X,Y,W:single; doCenter:Boolean=true):integer;
  procedure guiDrawCheckBox(Text:string; X,Y:single;var doVal:Boolean);
  procedure guiDrawRadioButtons(Text:string; X,Y:single;var doVal:integer);
  procedure guiDrawTabs(X,Y,W,H:Integer;Name,Tabs:string; var SelId:integer);
  procedure guiDrawEdit(ed:PMyEdit);
  procedure guiDrawComboBox(cm:PMyComboBox);
  procedure guiDrawMemoBorder(X,Y,W,H:single;Transparenty:Byte=255);
  procedure guiDrawProgressBar(X,Y,W,Coef:single);
  procedure guiDrawTrackBar(track:PMyTrakBar);
  procedure guiDrawSelection(X,Y,W:single;sel:Boolean);
  procedure guiDrawTable(tb:PMyTable;Transparenty:byte=255);

  procedure guiShowPopup(X,Y:integer;pp:PMyPopup);

  procedure guiInitEdit(ed:PMyEdit;X,Y,Width:integer;Text:String='';Hint:String='';TextType:byte=tt_normal;TTValue:Pinteger=nil);
  procedure guiInitComboBox(cb:PMyComboBox;X,Y,Width:integer);
  procedure guiInitTable(tb:PMyTable;X,Y,W,H:integer);
  procedure guiTableAddHeader(tb:PMyTable;Text:string;Width:single;Align:byte; Headertype:byte=ht_string);
  procedure gupInitPopup(pp:PMyPopup;Texts:string;OnSelect:Pointer=nil);
  procedure guiPopupAddAction(pp:PMyPopup;Text:string);

  procedure guiInit(Dir:string);
  procedure guiProcess;
  procedure guiPlayClick;
  procedure guiDraw;
  procedure guiDrawMouse;
  procedure guiFocus;
  function guiMouseClick:Boolean;
  function guiMouseClickR:Boolean;
  function MouseInBorder(X,Y,W,H:single):Boolean;

implementation

  function GetClipboardText(Wnd: HWND; var Str: string): Boolean;
  var
    hData: HGlobal;
  begin
    Result := True;
    if OpenClipboard(Wnd) then
    begin
      try
        hData := GetClipboardData(CF_TEXT);
        if hData <> 0 then
        begin
          try
            SetString(Str, PChar(GlobalLock(hData)), GlobalSize(hData));
          finally
            GlobalUnlock(hData);
          end;
        end
        else
          Result := False;
        Str := PChar(@Str[1]);
      finally
        CloseClipboard;
      end;
    end
    else
      Result := False;
  end;

  procedure SetClipboardText(Str:string);
  var
    hMem: Cardinal; pMem: PChar;
  begin
     OpenClipboard(0);
     hMem := GlobalAlloc(GMEM_DDESHARE or GMEM_MOVEABLE, Length(Str)+1);
     pMem := GlobalLock(hMem);
     lstrcpy (PChar(pMem), @Str[1]);
     GlobalUnlock(hMem);
     EmptyClipboard;
     SetClipboardData(CF_TEXT, hMem);
     SetClipboardData(CF_LOCALE, hMem);
     CloseClipboard;
     GlobalFree(hMem);
  end;

  procedure ReloadTb(pr:PMyTable);
  var l:Integer;
  begin
    l:=(pr.H div elHeight)-1;
    pr.prOffset:=Round((pr.Offset/(pr.Size.Y-l))*(l*elHeight-comboMovePHeight-comboMoveHeight*2-5));
  end;

  procedure ReloadPr(pr:PMyComboBox);
  begin
    pr.prOffset:=Round((pr.Offset/(Length(pr.Values)-comboSize))*(comboSize*elHeight-comboMovePHeight-comboMoveHeight*2-2));
  end;

  procedure guiPlayClick;
  begin
    Snd_Play(sndButtonClick,false);
  end;

  procedure guiSelectAll(asEd:PMyEdit);
  begin
    asEd.SelectEnd:=0;
    asEd.SelectStart:=Length(asEd.Text);
  end;

  procedure guiDeleteSelected(asEd:PMyEdit);
  var st,l:Integer;
  begin
    if asEd.SelectEnd>asEd.SelectStart then begin
      st:=asEd.SelectStart;
      l:=asEd.SelectEnd-st;
    end else if asEd.SelectEnd<asEd.SelectStart then begin
      st:=asEd.SelectEnd;
      l:=asEd.SelectStart-st;
    end else Exit;
    asEd.Text:=asEd.LeftText+asEd.RightText;
    asEd.LeftText:=Copy(asEd.Text,1,st);
    asEd.RightText:=Copy(asEd.Text,st+l+1,Length(asEd.Text));
    asEd.Text:=asEd.LeftText+asEd.RightText;
    asEd.SelectStart:=0;
    asEd.SelectEnd:=0;
    Key_BeginReadText(PAnsiChar(asEd.LeftText));
  end;

  procedure guiCopySelected(asEd:PMyEdit);
  var st,l:Integer;
  begin
    if asEd.SelectEnd>asEd.SelectStart then begin
      st:=asEd.SelectStart;
      l:=asEd.SelectEnd-st;
    end else if asEd.SelectEnd<asEd.SelectStart then begin
      st:=asEd.SelectEnd;
      l:=asEd.SelectStart-st;
    end else Exit;
    SetClipboardText(Copy(asEd.Text,st+1,l));
  end;

  procedure guiPaste(asEd:PMyEdit);
  var st,l:Integer;
      s:string;
  begin
    guiDeleteSelected(asEd);
    //asEd.SelectStart:=Length(asEd.LeftText);
    GetClipboardText(HInstance,s);
    asEd.LeftText:=asEd.LeftText+s;
    //asEd.SelectEnd:=Length(asEd.LeftText);
    asEd.Text:=asEd.LeftText+asEd.RightText;
    Key_BeginReadText(PAnsiChar(asEd.LeftText));
    asEd.SelectStart:=0;
    asEd.SelectEnd:=0;
  end;

  function MouseInBorder(X,Y,W,H:single):Boolean;
  begin
    result:=(Mouse_X>=X) and (Mouse_Y>=Y) and (Mouse_X<=X+W) and (Mouse_Y<=Y+H);
  end;

  procedure guiPopupAddAction(pp:PMyPopup;Text:string);
  var id:Integer;
  begin
    id:=Length(pp.Items);
    SetLength(pp.Items,id+1);
    pp.Items[id].Text:=Text;
    pp.Items[id].Active:=True;
   // pp.Items[id].Action:=Action;
    if Length(Text)>pp.Width then pp.Width:=Length(Text);
  end;

  procedure guiShowPopup(X,Y:integer;pp:PMyPopup);
  begin
    Focus.FocusType:=ft_popup;
    Focus.asPopup:=pp;
    pp.X:=X;
    pp.Y:=Y;
  end;

  procedure gupInitPopup(pp:PMyPopup;Texts:string;OnSelect:Pointer=nil);

  begin
    while Pos('|',Texts)<>0 do begin
      guiPopupAddAction(pp,Copy(Texts,1,Pos('|',Texts)-1));
      Delete(Texts,1,Pos('|',Texts));
    end;
    guiPopupAddAction(pp,Texts);
    pp.OnSelect:=OnSelect;
  end;

  procedure guiInitTable(tb:PMyTable;X,Y,W,H:integer);
  begin
    tb.X:=X;
    tb.Y:=Y;
    tb.W:=W;
    tb.H:=(H div elHeight)*elHeight;
    tb.prOffset:=0;
    tb.Offset:=0;
    tb.Size.X:=0;
    tb.Size.Y:=0;
    tb.SelId:=-1;
  end;

  procedure guiTableAddHeader(tb:PMyTable; Text:string; Width:single; Align:byte; Headertype:byte=ht_string);
  begin
    SetLength(tb.Headers,tb.Size.X+1);
    tb.Headers[tb.Size.X].Text:=Text;
    tb.Headers[tb.Size.X].Width:=Width;
    tb.Headers[tb.Size.X].Align:=Align;
    tb.Headers[tb.Size.X].Htype:=Headertype;
    Inc(tb.Size.X);
  end;

  function GetBoolVal(b:boolean;s1,s2:string):string;
  begin
    if b then result:=s1 else result:=s2;
  end;

  procedure guiInitComboBox(cb:PMyComboBox;X,Y,Width:integer);
  begin
    cb.X:=X;
    cb.Y:=Y;
    cb.W:=Width;
  end;

  procedure guiInitEdit(ed:PMyEdit;X,Y,Width:integer;Text:String='';Hint:String='';TextType:byte=tt_normal;TTValue:Pinteger=nil);
  begin
    ed.X:=X;
    ed.Y:=Y;
    ed.W:=Width;
    if Text<>'' then ed.Text:=Text;
    if Hint<>'' then ed.Hint:=Hint;
    ed.TextType:=TextType;
    if Assigned(TTValue) then begin
      ed.TTNumbersValue:=TTValue;
      ed.Text:=U_IntToStr(TTValue^);
    end;
  end;

  procedure guiDrawTable(tb:PMyTable;Transparenty:byte=255);
  var X,Y,W,H,n,m,j,offs,l,k,dW,i:Integer;
     b:Boolean;
  begin
    l:=(tb.H div elHeight)-1;
    X:=round(tb.X); Y:=Round(tb.Y);
    W:=round(tb.W-tblWidth*2); H:=Round(tb.H-tblHeight*2);
    dW:=tb.W;
    r.X:=tblX; r.y:=tblY; r.W:=tblWidth; r.H:=tblHeight;
    csprite2d_Draw(txtMainTex,X,Y,tblWidth,tblHeight,0,r,Transparenty);
    r.X:=tblX+tblWidth;
    csprite2d_Draw(txtMainTex,X+W+tblWidth,Y,tblWidth,tblHeight,0,r,Transparenty);
    r.y:=tblY+tblHeight;
    csprite2d_Draw(txtMainTex,X+W+tblWidth,Y+H+tblHeight,tblWidth,tblHeight,0,r,Transparenty);
    r.X:=tblX; r.y:=tblY+tblHeight;
    csprite2d_Draw(txtMainTex,X,Y+H+tblHeight,tblWidth,tblHeight,0,r,Transparenty);
    r.X:=tblX+tblWidth; r.y:=tblY+tblHeight; r.W:=1;
    csprite2d_Draw(txtMainTex,X+tblWidth,Y+H+tblHeight,W,tblHeight,0,r,Transparenty);
    r.y:=tblY;
    csprite2d_Draw(txtMainTex,X+tblWidth,Y,W,tblHeight,0,r,Transparenty);
    r.X:=tblX; r.y:=tblY+tblHeight; r.W:=tblWidth; r.H:=1;
    csprite2d_Draw(txtMainTex,X,Y+tblHeight,tblWidth,H,0,r,Transparenty);
    r.X:=tblX+tblWidth;
    csprite2d_Draw(txtMainTex,X+W+tblWidth,Y+tblHeight,tblWidth,H,0,r,Transparenty);
    r.W:=1;
    csprite2d_Draw(txtMainTex,X+tblWidth,Y+tblHeight,W,H,0,r,Transparenty);
    if l<tb.Size.Y then begin
      Dec(dW,comboMoveWidth);
      i:=0;
      if Focus.FocusType=ft_none then
      if MouseInBorder(X+dW-2,Y+elHeight+1,comboMoveWidth,comboMoveHeight) then begin
        if Mouse_Down(M_BLEFT) then begin
          i:=1;
        end else
        if LbState then begin
          guiPlayClick;
          if tb.Offset>0 then Dec(tb.Offset);
          ReloadTb(tb);
        end;
      end;
      r.X:=comboMoveX+comboMoveWidth*i; r.y:=comboMoveY;
      r.W:=comboMoveWidth; r.H:=comboMoveHeight;
      csprite2d_Draw(txtMainTex,X+dW-2,Y+elHeight+1,comboMoveWidth,comboMoveHeight,0,r,Transparenty);
      i:=0;
      if Focus.FocusType=ft_none then
      if MouseInBorder(X+dW-2,Y+tb.H-comboMoveHeight-2,comboMoveWidth,comboMoveHeight) then begin
        if Mouse_Down(M_BLEFT) then begin
          i:=1;
        end else
        if LbState then begin
          guiPlayClick;
          if tb.Offset<tb.Size.Y-l then Inc(tb.Offset);
          ReloadTb(tb);
        end;
      end;
      r.X:=comboMoveX+comboMoveWidth*i; r.y:=comboMoveHeight+comboMoveY+comboMovePHeight;
      r.W:=comboMoveWidth; r.H:=comboMoveHeight;
      csprite2d_Draw(txtMainTex,X+dW-2,Y+tb.H-comboMoveHeight-2,comboMoveWidth,comboMoveHeight,0,r,Transparenty);
      if Focus.FocusType=ft_tablemove then begin
        i:=1;
      end else i:=0;
      r.X:=comboMoveX+comboMoveWidth*i; r.y:=comboMoveHeight+comboMoveY;
      r.W:=comboMoveWidth; r.H:=comboMovePHeight;
      csprite2d_Draw(txtMainTex,X+dW-2,Y+elHeight+comboMoveHeight+2+tb.prOffset,comboMoveWidth,comboMovePHeight,0,r,Transparenty);
      if MouseInBorder(X+dW-2,Y+elHeight+comboMoveHeight+2+tb.prOffset,comboMoveWidth,comboMovePHeight) then begin
        if Mouse_Down(M_BLEFT) and (LbState=false) then begin
          guiPlayClick;
          Focus.FocusType:=ft_tablemove;
          Focus.asTable:=tb;
          MoveOffset:=Mouse_Y-({Y+elHeight+comboMoveHeight+2+}tb.prOffset);
        end;
      end;
    end;
    offs:=Round(dW*tb.Headers[0].Width);
    r.X:=tblHX; r.y:=tblHY; r.W:=tblHWidth; r.H:=tblHHeight;
    for n:=1 to tb.Size.X-1 do begin
      csprite2d_Draw(txtMainTex,X+offs,Y,tblHWidth,tblHHeight,0,r,Transparenty);
      Inc(offs,Round(dW*tb.Headers[n].Width));
    end;
    offs:=0;
    for n:=0 to tb.Size.X-1 do begin
      case tb.Headers[n].Align of
        align_left:j:=2;
        align_center:j:=Round(dW*tb.Headers[n].Width/2-(Length(tb.Headers[n].Text)+1)*symbolWidth/2);
        align_right:j:=Round(dW*tb.Headers[n].Width-(Length(tb.Headers[n].Text)+1)*symbolWidth);
      end;
      guiDrawText(tb.Headers[n].Text,X+j+offs,Y);
      Inc(offs,Round(dW*tb.Headers[n].Width));
    end;
    if l>tb.Size.Y then l:=tb.Size.Y;
    for n:=0 to l-1 do begin
      offs:=2;
      for m:=0 to tb.Size.X-1 do begin
        case tb.Headers[m].Htype of

          ht_checkbox:begin
            case tb.Headers[m].Align of
              align_left:j:=0;
              align_center:j:=Round(dW*tb.Headers[m].Width/2-cboxWidth);
              align_right:j:=Round(dW*tb.Headers[m].Width-cboxWidth*2);
            end;
            b:=tb.Values[n+tb.Offset,m]='1';
            guiDrawCheckBox('',X+j+offs,Y+(n+1)*elHeight,b);
            tb.Values[n+tb.Offset,m]:=GetBoolVal(b,'1','0');
          end;
        end;
        Inc(offs,Round(dW*tb.Headers[m].Width));
      end;
      if n+tb.Offset=tb.SelId then begin
        guiDrawSelection(X,Y+(n+1)*elHeight,dW-2,true);
      end else
      if (Focus.FocusType=ft_none) and MouseInBorder(X,Y+(n+1)*elHeight,dW-4,elHeight-1) then begin
        guiDrawSelection(X,Y+(n+1)*elHeight,dW-2,false);
        if guiMouseClick then begin
          guiPlayClick;
          tb.SelId:=n+tb.Offset;
        end;
      end;
      offs:=2;
      for m:=0 to tb.Size.X-1 do begin
        case tb.Headers[m].Htype of
          ht_string:begin
            case tb.Headers[m].Align of
              align_left:j:=0;
              align_center:j:=Round(dW*tb.Headers[m].Width/2-(Length(tb.Values[n+tb.Offset,m])+1)*symbolWidth/2);
              align_right:j:=Round(dW*tb.Headers[m].Width-(Length(tb.Values[n+tb.Offset,m])+1)*symbolWidth);
            end;
            guiDrawText(tb.Values[n+tb.Offset,m],X+j+offs,Y+(n+1)*elHeight);
          end;
        end;
        Inc(offs,Round(dW*tb.Headers[m].Width));
      end;
    end;
  end;

  procedure guiDrawTrackBar(track:PMyTrakBar);
  var i,d:Integer;
  begin
    i:=0;
    d:=Round(track.X+(track.W-trackWidth+pbWidth*2)*(track.Value^/track.Max));
    if MouseInBorder(d,track.Y,trackWidth,trackHeight) and (Focus.FocusType=ft_none) then begin
      i:=1;
      if Mouse_Click(1) then begin
        guiPlayClick;
        Focus.FocusType:=ft_trackbar;
        Focus.asTrackBar:=track;
        track.LastValue:=track.Value^;
        track.prOffset:=Mouse_X-d;
      end;
    end;
    guiDrawProgressBar(track.X,track.Y,track.W,track.Value^/track.Max);
    r.X:=trackX; r.y:=trackY+i*trackHeight;
    r.W:=trackWidth; r.H:=trackHeight;
    csprite2d_Draw(txtMainTex,d,track.Y,trackWidth,trackHeight,0,r);
  end;


  function guiDrawTabButton(Text:string; X,Y,W:single; Selected:boolean):boolean;
  var i:Integer;

  begin
    if Selected then i:=2 else i:=0;
    Result:=False;
    if MouseInBorder(X,Y,W+tabWidth,tabHeight) and (Focus.FocusType=ft_none) then begin
      if i=0 then i:=1;                             
      if guiMouseClick then begin
        guiPlayClick;
        Focus.FocusType:=ft_none;
        Result:=True;
      end;
    end;
    r.X:=tabX+i*tabWidth;
    r.y:=tabY;
    r.W:=tabWidth/2;r.H:=tabHeight;
    csprite2d_Draw(txtMainTex,X,Y,tabWidth/2,tabHeight,0,r);
    r.X:=r.X+tabWidth/2;
    csprite2d_Draw(txtMainTex,X+W+tabWidth/2,Y,tabWidth/2,tabHeight,0,r);
    r.W:=1;
    csprite2d_Draw(txtMainTex,X+tabWidth/2,Y,W,tabHeight,0,r);

    guiDrawText(Text,X+tabWidth/2+W/2,Y+textYOffset,align_center);
  end;

  procedure guiDrawTabs(X,Y,W,H:Integer;Name,Tabs:string; var SelId:integer);
  var str,ActiveStr:string;
      iOff,i,k:Integer;
  begin

    iOff:=0;k:=0;
    while Pos('|',Tabs)<>0 do begin
      str:=Copy(Tabs,1,Pos('|',Tabs)-1);
      if guiDrawTabButton(str,X+iOff+2,Y+H,Length(str)*symbolWidth,SelId=k) then
        SelId:=k;
      if SelId=k then begin
        ActiveStr:=str;
      end;
      iOff:=iOff+Length(str)*symbolWidth+tabWidth+1;
      Inc(k);
      Delete(Tabs,1,Pos('|',Tabs));
    end;
    guiDrawForm(Name+' - '+ActiveStr,X,Y,W,H);
  end;

  procedure guiProcess;
  var asEd:PMyEdit;
      n,i,edlen:Integer;
  begin
    case Focus.FocusType of
      ft_edit:begin
        Inc(selVal);
        asEd:=Focus.asEdit;
        key_GetText(asEd.LeftText);
        key_EndReadText;
        asEd.Text:=asEd.LeftText+asEd.RightText;
        if asEd.TextType=tt_numbers then begin
          n:=1;
          while n<=Length(asEd.Text) do begin
            if not (asEd.Text[n] in ['0'..'9']) then begin
              Delete(asEd.Text,n,1);
              Dec(n);
            end;
            Inc(n);
          end;
          if asEd.Text='' then asEd.Text:='0';
          if Assigned(asEd.TTNumbersValue) then
            asEd.TTNumbersValue^:=U_StrToInt(PAnsiChar(asEd.Text));
        end;
        if Key_Press(K_LEFT) and (Length(asEd.LeftText)>0) then begin
          asEd.RightText:=asEd.LeftText[Length(asEd.LeftText)]+asEd.RightText;
          Delete(asEd.LeftText,Length(asEd.LeftText),1);
          Key_BeginReadText(PAnsiChar(asEd.LeftText));
        end;
        if Key_Press(K_RIGHT) and (Length(asEd.RightText)>0) then begin
          asEd.LeftText:=asEd.LeftText+asEd.RightText[1];
          Delete(asEd.RightText,1,1);
          Key_BeginReadText(PAnsiChar(asEd.LeftText));
        end;
        if Key_Press(K_DELETE) and ((Length(asEd.RightText)>0) or ((asEd.SelectStart<>asEd.SelectEnd) and (Length(asEd.Text)>0))) then begin
          if asEd.SelectStart<>asEd.SelectEnd then
            guiDeleteSelected(asEd) else Delete(asEd.RightText,1,1);
        end;
        if Key_Down(K_CTRL) and Key_Press(K_V) then begin
          guiPaste(asEd);
        end;
        if Key_Down(K_CTRL) and Key_Press(K_C) and (asEd.SelectStart<>asEd.SelectEnd) then begin
          guiCopySelected(asEd);
        end;
        if Key_Down(K_CTRL) and Key_Press(K_X) and (asEd.SelectStart<>asEd.SelectEnd) then begin
          guiCopySelected(asEd);
          guiDeleteSelected(asEd);
        end;
        if Key_Down(K_CTRL) and Key_Press(K_A) then begin
          guiSelectAll(asEd);
        end;
        edlen:=asEd.W div symbolWidth;
        i:=round(Mouse_X-asEd.X-editWidth+symbolWidth/2) div symbolWidth+asEd.Offset;
        if i>Length(asEd.Text) then i:=Length(asEd.Text);
        if i<0 then i:=0;
        if (asEd.SelectStart<>asEd.SelectEnd) and (Mouse_Down(M_BLEFT)) then begin
          if (i<asEd.Offset) and (asEd.Offset>0) then Dec(asEd.Offset);
          if (i>asEd.Offset+edlen-1) and (asEd.Offset<Length(asEd.Text)-edlen+1) then Inc(asEd.Offset);
        end;
      end;
    end;
  end;

  procedure guiDrawSelection(X,Y,W:single;sel:Boolean);
  begin
    if sel then r.Y:=elY+elHeight else r.Y:=elY;
    r.X:=elX; r.W:=elWidth/2; r.H:=elHeight;
    csprite2d_Draw(txtMainTex,X,Y,elWidth/2,elHeight,0,r);
    r.X:=elX+elWidth/2;
    csprite2d_Draw(txtMainTex,X+W-elWidth/2,Y,elWidth/2,elHeight,0,r);
    r.W:=0;
    csprite2d_Draw(txtMainTex,X+elWidth/2,Y,W-elWidth,elHeight,0,r);
  end;

  procedure guiFocus;
  var asCb:PMyComboBox;
      asTr:PMyTrakBar;
      asPP:PMyPopup;
      n,i,j:Integer;
  begin
    case Focus.FocusType of
      ft_popup:begin
        asPP:=Focus.asPopup;
        guiDrawMemoBorder(asPP.X,asPP.Y,(asPP.Width+2)*symbolWidth-memoWidth*2+4,Length(asPP.Items)*elHeight-memoHeight*2+4);
        for i:=0 to Length(asPP.Items)-1 do begin
          if asPP.Items[i].Active and MouseInBorder(asPP.X+2,asPP.Y+i*elHeight+2,(asPP.Width+2)*symbolWidth,elHeight-1) and guiMouseClick then begin
            guiPlayClick;
            Focus.FocusType:=ft_none;
            //asPP.Selected:=i;
            if Assigned(asPP.OnSelect) then
              asPP.OnSelect(i);
            LBState:=false;
            Break;
          end;
        end;
      end;
      ft_trackbar:begin
        asTr:=Focus.asTrackBar;
        i:=Round(asTr.Max*(Mouse_X-asTr.X-asTr.prOffset)/(asTr.W-trackWidth+pbWidth*2));
        if i<0 then i:=0; if i>asTr.Max then i:=asTr.Max;
        asTr.Value^:=i;
        if (asTr.LastValue<>asTr.Value^) and Assigned(asTr.OnChange) then begin
          asTr.OnChange;
        end;
        asTr.LastValue:=asTr.Value^
      end;
      ft_combobox:begin
        asCb:=Focus.asComboBox;
        i:=Length(asCb.Values);
        if i>comboSize then i:=comboSize;
        for n:=asCb.Offset to asCb.Offset+i-1 do begin
          j:=n-asCb.Offset;
          if MouseInBorder(asCb.X+2,asCb.Y+comboHeight+1+j*elHeight,asCb.W+comboSelWidth-comboMoveWidth-2,elHeight-1) then begin
            if guiMouseClick then begin
              guiPlayClick;
              asCb.SelId:=n;
              Focus.FocusType:=ft_none;
            end;
          end;
        end;
      end;
    end;
  end;

  procedure guiDraw;
  var asCb:PMyComboBox;
      asEd:PMyEdit;
      asTr:PMyTrakBar;
      asPP:PMyPopup;
      asTb:PMyTable;
      n,i,j,st,l,eOffset:Integer;
      b:Boolean;
      s:string;
  begin
    case Focus.FocusType of
      ft_popup:begin
        asPP:=Focus.asPopup;
        guiDrawMemoBorder(asPP.X,asPP.Y,(asPP.Width+2)*symbolWidth-memoWidth*2+4,Length(asPP.Items)*elHeight-memoHeight*2+4);
        for i:=0 to Length(asPP.Items)-1 do begin
          if asPP.Items[i].Active then begin
            if MouseInBorder(asPP.X+2,asPP.Y+i*elHeight+2,(asPP.Width+2)*symbolWidth,elHeight-1) then begin
              guiDrawSelection(asPP.X+2,asPP.Y+i*elHeight+2,(asPP.Width+2)*symbolWidth,false);
            end;
            guiDrawText(asPP.Items[i].Text,asPP.X+4,asPP.Y+i*elHeight+2);
          end else
            guiDrawText(asPP.Items[i].Text,asPP.X+4,asPP.Y+i*elHeight+2,align_left,False,96);
        end;
      end;
      ft_trackbar:begin
        asTr:=Focus.asTrackBar;
        i:=Round(asTr.X+(asTr.W-trackWidth+pbWidth*2)*(asTr.Value^/asTr.Max));
        guiDrawText(U_IntToStr(asTr.Value^),i+trackWidth,asTr.Y);
      end;
      ft_edit:begin
        b:=True;
        asEd:=Focus.asEdit;
          r.X:=layX; r.Y:=layY;
          if RuLayout then r.X:=r.X+layWidth;
          r.W:=layWidth; r.H:=layHeight;
          csprite2d_Draw(txtMainTex,asEd.X+asEd.W-layWidth+editWidth,asEd.Y-layHeight,layWidth,layHeight,0,r);
          if MouseInBorder(asEd.X+asEd.W-layWidth+editWidth,asEd.Y-layHeight,layWidth,layHeight) then begin
            guiDrawText('',asEd.X+asEd.W+editWidth+2,asEd.Y);
            r.X:=layX+layWidth*3;
            csprite2d_Draw(txtMainTex,asEd.X+asEd.W-layWidth+editWidth,asEd.Y-layHeight,layWidth,layHeight,0,r);
            if guiMouseClick then begin
              guiPlayClick;
              RuLayout:=not RuLayout;
            {  if RuLayout then Key_LoadLayout(K_LAYOUT_RUS) else
                Key_LoadLayout(K_LAYOUT_ENG);}
              LbState:=False;
            end;
          end;
          r.X:=layX+layWidth*2;
          csprite2d_Draw(txtMainTex,asEd.X+asEd.W-layWidth*2+editWidth-2,asEd.Y-layHeight,layWidth,layHeight,0,r);
          if MouseInBorder(asEd.X+asEd.W-layWidth*2+editWidth-2,asEd.Y-layHeight,layWidth,layHeight) then begin
            guiDrawText('',asEd.X+asEd.W+editWidth+2,asEd.Y);
            r.X:=layX+layWidth*3;
            csprite2d_Draw(txtMainTex,asEd.X+asEd.W-layWidth*2+editWidth-2,asEd.Y-layHeight,layWidth,layHeight,0,r);
            if guiMouseClick then begin
              guiPlayClick;
              b:=asEd.SelectStart-asEd.SelectEnd<>0;
              EditActionsPopup.Items[0].Active:=b;
              EditActionsPopup.Items[1].Active:=b;
              EditActionsPopup.Items[3].Active:=b;
              EditActionsPopup.Items[4].Active:=asEd.Text<>'';
              guiShowPopup(asEd.X+asEd.W-layWidth*2+editWidth-2,asEd.Y-layHeight,@EditActionsPopup);
              LbState:=False;
            end;
          end;
      end;
      ft_tablemove:begin
        asTb:=Focus.asTable;
        asTb.prOffset:=Mouse_Y-MoveOffset;
        if asTb.prOffset<0 then asTb.prOffset:=0;
        l:=(asTb.H div elHeight)-1;
        if asTb.prOffset>l*elHeight-2*comboMoveHeight-comboMovePHeight-5 then asTb.prOffset:=l*elHeight-2*comboMoveHeight-comboMovePHeight-5;
        asTb.Offset:=Round((asTb.prOffset/(l*elHeight-comboMovePHeight-comboMoveHeight*2-5)*(asTb.Size.Y-l)));
        if asTb.Offset>asTb.Size.Y-l then asTb.Offset:=asTb.Size.Y-l;
        
        if not Mouse_Down(M_BLEFT) then begin
          guiPlayClick;
          Focus.FocusType:=ft_none;
          LbState:=False;
        end;
      end;
      ft_combobox,ft_comboboxmove:begin
        j:=0; eOffset:=0;
        asCb:=Focus.asComboBox;
        if asCb.ElementsTexture<>nil then eOffset:=elHeight;
        i:=Length(asCb.Values);
        if i>comboSize then begin
          i:=comboSize;
          j:=comboMoveWidth;
        end;
        guiDrawMemoBorder(asCb.X,asCb.Y+comboHeight-1,asCb.W-memoWidth-1,i*elHeight-memoHeight*2+4);
        for n:=asCb.Offset to asCb.Offset+i-1 do begin
          i:=n-asCb.Offset;
          if MouseInBorder(asCb.X+2,asCb.Y+comboHeight+1+i*elHeight,asCb.W+comboSelWidth-6-j,elHeight-1) and (Focus.FocusType=ft_combobox) then begin
            guiDrawSelection(asCb.X+2,asCb.Y+comboHeight+1+i*elHeight,asCb.W+comboSelWidth-6-j,false);
          end else if asCb.SelId=n then begin
            guiDrawSelection(asCb.X+2,asCb.Y+comboHeight+1+i*elHeight,asCb.W+comboSelWidth-6-j,true);
          end;
          s:=asCb.Values[n];
          if Length(s)>asCb.W div symbolWidth then s:=Copy(s,1,asCb.W div symbolWidth);
          if eOffset<>0 then begin

            asprite2d_Draw(asCb.ElementsTexture,asCb.X+2,asCb.Y+comboHeight+i*elHeight,
              elHeight,elHeight,0,n+1);
          end;
          guiDrawText(s,asCb.X+2+eOffset,asCb.Y+comboHeight+i*elHeight);
        end;
        if j<>0 then begin
          r.X:=comboLineX; r.Y:=comboLineY; r.W:=comboLineWidth; r.H:=comboLineHeight;
          csprite2d_Draw(txtMainTex,
            asCb.X+asCb.W+2,
            asCb.Y+comboHeight+1+comboMoveHeight,
            comboMoveWidth,comboSize*elHeight-comboMoveHeight,0,r);
          r.X:=comboMoveX; r.Y:=comboMoveY; r.W:=comboMoveWidth; r.H:=comboMoveHeight;
          if MouseInBorder(asCb.X+asCb.W+2,
            asCb.Y+comboHeight+1,
            comboMoveWidth,comboMoveHeight) and (Focus.FocusType=ft_combobox) then begin
            if guiMouseClick then begin
              guiPlayClick;
              if asCb.Offset>0 then Dec(asCb.Offset);
              ReloadPr(asCb);
            end;
            if Mouse_Down(M_BLEFT) then r.X:=r.X+comboMoveWidth;
          end;
          csprite2d_Draw(txtMainTex,
            asCb.X+asCb.W+2,
            asCb.Y+comboHeight+1,
            comboMoveWidth,comboMoveHeight,0,r);
          r.X:=comboMoveX; r.Y:=comboMoveY+comboMoveHeight+comboMovePHeight; r.W:=comboMoveWidth; r.H:=comboMoveHeight;
          if MouseInBorder(asCb.X+asCb.W+2,
            asCb.Y+(comboSize-1)*elHeight+comboHeight+5,
            comboMoveWidth,comboMoveHeight) and (Focus.FocusType=ft_combobox) then begin
            if guiMouseClick then begin
              guiPlayClick;
              if asCb.Offset<Length(asCb.Values)-comboSize then inc(asCb.Offset);
              ReloadPr(asCb);
            end;
            if Mouse_Down(M_BLEFT) then r.X:=r.X+comboMoveWidth;
          end;
          csprite2d_Draw(txtMainTex,
            asCb.X+asCb.W+2,
            asCb.Y+comboHeight+(comboSize-1)*elHeight+5,
            comboMoveWidth,comboMoveHeight,0,r);
          r.X:=comboMoveX; r.Y:=comboMoveY+comboMoveHeight; r.W:=comboMoveWidth; r.H:=comboMovePHeight;

          if Focus.FocusType=ft_combobox then begin
            if MouseInBorder(asCb.X+asCb.W+2,
              asCb.Y+asCb.prOffset+comboHeight+comboMoveHeight+2,
              comboMoveWidth,comboMovePHeight) then begin
              if Mouse_Down(M_BLEFT) then begin
                guiPlayClick;
                Focus.FocusType:=ft_comboboxmove;
                MoveOffset:=Mouse_Y-asCb.prOffset;
              end;
            end;
          end else begin
            r.X:=r.X+comboMoveWidth;
            asCb.prOffset:=Mouse_Y-MoveOffset;
            if asCb.prOffset<0 then asCb.prOffset:=0;
            if asCb.prOffset>comboSize*elHeight-2*comboMoveHeight-comboMovePHeight-2 then
              asCb.prOffset:=comboSize*elHeight-2*comboMoveHeight-comboMovePHeight-2;
            asCb.Offset:=Round(((asCb.prOffset/(comboSize*elHeight-comboMovePHeight-comboMoveHeight*2-2))*(length(asCb.Values)-comboSize)));
            if asCb.Offset>Length(asCb.Values)-comboSize then asCb.Offset:=Length(asCb.Values)-comboSize;
            if not Mouse_Down(M_BLEFT) then begin
              guiPlayClick;
              Focus.FocusType:=ft_combobox;
              LbState:=False;
            end;
          end;
          csprite2d_Draw(txtMainTex,
            asCb.X+asCb.W+2,
            asCb.Y+asCb.prOffset+comboHeight+comboMoveHeight+2,
            comboMoveWidth,comboMovePHeight,0,r);
        end;
      end;
    end;
    if guiMouseClick or guiMouseClickR then begin
      if Focus.FocusType<>ft_none then begin
        guiPlayClick;
        Focus.FocusType:=ft_none;
      end;
    end;
    LbState:=Mouse_Down(M_BLEFT);
    RbState:=Mouse_Down(M_BRIGHT);
  end;



  function guiMouseClick:Boolean;
  begin
    Result:=(Mouse_Down(M_BLEFT)=False) and (LbState);
    if Result then LbState:=False;
  end;

  function guiMouseClickR:Boolean;
  begin
    Result:=(Mouse_Down(M_BRIGHT)=False) and (RbState);
    if Result then RbState:=False;
  end;

  procedure guiDrawMouse;
  begin
     ssprite2d_Draw(txtCursor, mouse_X-32, mouse_Y-32, 64, 64, 0);
  end;

  procedure OnEditPopupAction(selected:Integer);
  begin
    case selected of
      0:begin
        guiCopySelected(Focus.asEdit);
        guiDeleteSelected(Focus.asEdit);
      end;
      1:begin
        guiCopySelected(Focus.asEdit);
      end;
      2:begin
        guiPaste(Focus.asEdit);
      end;
      3:begin
        guiDeleteSelected(Focus.asEdit);
      end;
      4:begin
        guiSelectAll(Focus.asEdit);
        guiDeleteSelected(Focus.asEdit);
      end;
    end;
    Focus.FocusType:=ft_edit;
  end;

  procedure guiInit(Dir:string);
  begin
    Snd_Init;
    txtMainTex:= Tex_LoadFromFile(PAnsiChar(Dir+'/Gui.tga'),0, TEX_DEFAULT_2D);
    txtFont:= Tex_LoadFromFile(PAnsiChar(Dir+'/Thefont.tga'),0,TEX_DEFAULT_2D);
    txtCursor:= Tex_LoadFromFile(PAnsiChar(Dir+'/Cursor.tga'),0,TEX_DEFAULT_2D);
    tex_SetFrameSize(txtFont,symbolWidth,symbolHeight);
    sndButtonClick := Snd_LoadFromFile(PAnsiChar(Dir+'/buttonclick.wav'),1);

    gupInitPopup(@EditActionsPopup,'|||| ',@OnEditPopupAction);

   // Key_LoadLayout(K_LAYOUT_RUS);

    //VHnd := DWORD(zgl_Get(gENGINE_HWND)^);
  end;

  procedure guiDrawText(Text:string; X,Y:single; Align:byte=align_left; doHover:Boolean=false;trans:byte=255; tColor:Integer = textColor);
  var cl:integer;
      n,i,jx,jy:Integer;
  begin
    case Align of
      align_right: X:=X-symbolWidth*Length(text)-1;
      align_center: X:=X-symbolWidth*Length(text)/2-1;
    end;
    if doHover then cl:=textHoverColor else cl:=tColor;

    fx_SetColorMode(FX_COLOR_MIX);
    fx2d_SetColor(cL);
    jx:=Round(x); jy:=Round(y);
    for n:=1 to Length(Text) do begin
      i:=Ord(text[n])-31;
      if i = -18 then begin
        jX:=Round(x);
        jY:=jY+10;
        Continue;
      end;
      asprite2d_Draw(txtFont,jX+textXOffset,jY+textYOffset,symbolWidth,symbolHeight,0, i,trans);
      Inc(jX,symbolWidth);
    end;
  end;

  procedure guiDrawProgressBar(X,Y,W,Coef:single);
  begin
    r.X:=pbX; r.Y:=pbY; r.W:=pbWidth; r.H:=pbHeight;
    csprite2d_Draw(txtMainTex,X,Y,pbWidth,pbHeight,0,r);
    r.X:=pbX+pbWidth; r.W:=0;
    csprite2d_Draw(txtMainTex,X+pbWidth,Y,W*Coef,pbHeight,0,r);
    r.X:=pbX+pbWidth+1; r.W:=1;
    csprite2d_Draw(txtMainTex,X+pbWidth+W*Coef,Y,W*(1-Coef),pbHeight,0,r);
    r.X:=pbX+pbWidth+2; r.W:=pbWidth;
    csprite2d_Draw(txtMainTex,X+pbWidth+W,Y,pbWidth,pbHeight,0,r);
  end;

  procedure guiDrawEdit(ed:PMyEdit);
  var s:string;
      i,st,l,n,edlen,ds,dl,dn,offset,caret:Integer;
  begin
    r.X:=editX; r.Y:=editY;
    r.W:=editWidth; r.H:=editHeight;
    csprite2d_Draw(txtMainTex,ed.X,ed.Y,editWidth,editHeight,0,r);
    r.X:=editX+editWidth;
    csprite2d_Draw(txtMainTex,ed.X+editWidth+ed.W,ed.Y,editWidth,editHeight,0,r);
    r.W:=0; r.X:=editX+editWidth;
    csprite2d_Draw(txtMainTex,ed.X+editWidth,ed.Y,ed.W,editHeight,0,r);
    edlen:=ed.W div symbolWidth;
    s:=Copy(ed.Text,ed.Offset+1,edlen);
    
   { if Length(s)>i then begin
      if ed.SelectStart<>ed.SelectEnd then caret:=ed.SelectEnd else
        caret:=Length(ed.LeftText);
      offset:=caret-i-1;
      s:=Copy(s,offset,i);
    end else offset:=0;   }
    if ed.Hint<>'' then begin
      guiDrawText(ed.Hint,ed.X+ed.W+editWidth*2+2,ed.Y);
    end;

    guiDrawText(s,ed.X,ed.Y);

    n:=length(ed.LeftText)-ed.Offset;
    //if ed.Offset>0 then Inc(n);
    if n>edlen then n:=edlen;
    if n<0 then n:=0;

    st:=ed.SelectStart;
    l:=ed.SelectEnd-st;
    if l<0 then begin
      st:=ed.SelectEnd;
      l:=ed.SelectStart-st;
    end;
    if ((Focus.FocusType=ft_edit) or (Focus.FocusType=ft_popup)) and (Focus.asEdit=ed) then begin
      if l<>0 then begin
        ds:=st-ed.Offset;
        dl:=l;
        if ds<0 then begin
          Inc(dl,ds+1);
          ds:=0;
        end;
        if dl>edlen-ds then
          dl:=edlen-ds;
        r.X:=editselX; r.y:=editselY; r.W:=editselWidth; r.H:=editselHeight;
        csprite2d_Draw(txtMainTex,ed.X+ds*symbolWidth,ed.Y+2,editselWidth,editselHeight,0,r);
        r.W:=1; r.X:=r.X+editselWidth;
        csprite2d_Draw(txtMainTex,ed.X+ds*symbolWidth+editselWidth,ed.Y+2,dl*symbolWidth,editselHeight,0,r);
        r.X:=r.X+1; r.W:=editselWidth;
        csprite2d_Draw(txtMainTex,ed.X+ds*symbolWidth+editselWidth+dl*symbolWidth,ed.Y+2,editselWidth,editselHeight,0,r);
      end else begin
        r.X:=selX; r.y:=selY; r.W:=selWidth; r.H:=selHeight;
        csprite2d_Draw(txtMainTex,ed.X+1+n*symbolWidth,ed.Y,selWidth,selHeight,0,r);
      end;
    end;
    i:=round(Mouse_X-ed.X-editWidth+symbolWidth/2) div symbolWidth+ed.Offset;
    //if (ed.Offset>0) and (Mouse_Down(M_BLEFT)=false) then dec(i);
    if i>Length(ed.Text) then i:=Length(ed.Text);
    if i<0 then i:=0;
    if MouseInBorder(ed.X,ed.Y,comboWidth*2+ed.W,editHeight) and ((Focus.FocusType=ft_none) or ((Focus.FocusType=ft_edit) and (Focus.asEdit=ed))) then begin
      if Mouse_Down(M_BLEFT) and (LbState=False) then begin
        guiPlayClick;
        Focus.FocusType:=ft_edit;
        ed.LeftText:=Copy(ed.Text,1,i);
        ed.RightText:=Copy(ed.Text,i+1,Length(ed.Text)-i);
        Key_BeginReadText(PAnsiChar(ed.LeftText));
        Focus.asEdit:=ed;
        ed.SelectStart:=i;
        ClickOnEdit:=True;
      end;

    end;
    if (Focus.FocusType=ft_edit) and (Focus.asEdit=ed) then begin
      if (ed.SelectStart=ed.SelectEnd) and (Mouse_Down(M_BLEFT)=false) then begin
        if (Length(ed.LeftText)<ed.Offset) and (ed.Offset>0) then Dec(ed.Offset);
        if (Length(ed.LeftText)>ed.Offset+edlen-1) and (ed.Offset<Length(ed.Text)-edlen+1) then Inc(ed.Offset);
      end;
      if (Mouse_Down(M_BLEFT)=False) and LbState and ClickOnEdit then begin
        if ed.SelectEnd-ed.SelectStart<>0 then
          guiPlayClick;
        LbState:=False;
        ed.LeftText:=Copy(ed.Text,1,i);
        ed.RightText:=Copy(ed.Text,i+1,Length(ed.Text)-i);
        Key_BeginReadText(PAnsiChar(ed.LeftText));
        ClickOnEdit:=False;
      end;
      if Mouse_Down(M_BLEFT) and ClickOnEdit then begin
        ed.SelectEnd:=i;
      end;
    end;
  end;

  procedure guiDrawComboBox(cm:PMyComboBox);
  var eOffset:Integer;
  begin
    if cm.ElementsTexture<>nil then eOffset:=elHeight else eOffset:=0;
    r.X:=comboX; r.Y:=comboY;
    r.W:=comboWidth; r.H:=comboHeight;
    csprite2d_Draw(txtMainTex,cm.X,cm.Y,editWidth,comboHeight,0,r);
    if (Length(cm.Values)>0) and MouseInBorder(cm.X,cm.Y,comboSelWidth+cm.W+comboWidth,comboHeight) and (Focus.FocusType=ft_none) then begin
      if guiMouseClick then begin
        guiPlayClick;
        if (Focus.FocusType=ft_combobox) and (Focus.asComboBox=cm) then begin
          Focus.FocusType:=ft_none;
        end else begin
          Focus.FocusType:=ft_combobox;
          Focus.asComboBox:=cm;
          //cm.Offset:=0;
          //cm.prOffset:=0;
        end;
      end;
      r.X:=comboX+comboWidth+comboSelWidth+1;
    end else begin
      r.X:=comboX+comboWidth+1;
    end;
    r.W:=comboSelWidth;
    csprite2d_Draw(txtMainTex,cm.X+comboWidth+cm.W,cm.Y,comboSelWidth,comboHeight,0,r);
    r.W:=0; r.X:=comboX+comboWidth;
    csprite2d_Draw(txtMainTex,cm.X+comboWidth,cm.Y,cm.W,comboHeight,0,r);
    if eOffset<>0 then begin
      asprite2d_Draw(cm.ElementsTexture,cm.X+1,cm.Y,
        elHeight,elHeight,0,cm.SelId+1);
    end;
    if Length(cm.Values)>0 then
      guiDrawText(cm.Values[cm.SelId],cm.X+eOffset+1,cm.Y)
    else
      guiDrawText(' ',cm.X,cm.Y,align_left,False,128)
  end;

  procedure guiDrawRadioButtons(Text:string; X,Y:single;var doVal:integer);
  var i,n:Integer;
      s:string;
      b:Boolean;
  begin
    n:=0;
    while pos('|',Text)<>0 do begin
      s:=Copy(Text,1,Pos('|',Text)-1);
      Delete(Text,1,Pos('|',Text));
      if n=doVal then i:=0 else i:=1;
      b:=False;
      if MouseInBorder(X,Y+n*rdHeight,Length(s)*symbolWidth+rdWidth,rdHeight-1) and (Focus.FocusType=ft_none) then begin
        i:=i+2;
        if guiMouseClick then begin
          guiPlayClick;
          doVal:=n;
          Focus.FocusType:=ft_none;
        end;
        b:=True;
      end;
      r.X:=rdX; r.Y:=rdY+i*rdHeight;
      r.W:=rdWidth; r.H:=rdHeight;
      csprite2d_Draw(txtMainTex,X,Y+n*rdHeight,rdWidth,rdHeight,0,r);
      guiDrawText(s,X+rdWidth,Y+n*rdHeight,align_left,b);

      Inc(n);
    end;
  end;

  procedure guiDrawCheckBox(Text:string; X,Y:single;var doVal:Boolean);
  var i:Integer;
      b:Boolean;
  begin
    if doVal then i:=0 else i:=1;
    b:=False;
    if MouseInBorder(X,Y,length(Text)*symbolWidth+cboxWidth,cboxHeight) and (Focus.FocusType=ft_none) then begin
      i:=i+2;
      if guiMouseClick then begin
        guiPlayClick;
        doVal:=not doVal;
        Focus.FocusType:=ft_none;
      end;
      b:=True;
    end;
    r.X:=cboxX; r.Y:=cboxY+i*cboxHeight;
    r.W:=cboxWidth; r.H:=cboxHeight;
    csprite2d_Draw(txtMainTex,X,Y,cboxWidth,cboxHeight,0,r);
    guiDrawText(Text,X+cboxWidth,Y,align_left,b);
  end;

  function guiDrawButton(Text:string; X,Y,W:single; doCenter:Boolean=true):integer;
  var i:Integer;

  begin
    i:=0;
    W:=W-buttonWidth;
    Result:=button_none;
    if MouseInBorder(X,Y,W+buttonWidth,buttonHeight) and (Focus.FocusType=ft_none) then begin
      i:=1;
      Result:=button_hover;
      if Mouse_Down(M_BLEFT) then i:=2;
      if guiMouseClick then begin
        guiPlayClick;
        Focus.FocusType:=ft_none;
        Result:=button_click;
      end;
    end;
    r.X:=buttonX;
    r.y:=buttonY+i*buttonHeight;
    r.W:=buttonWidth/2;r.H:=buttonHeight;
    csprite2d_Draw(txtMainTex,X,Y,buttonWidth/2,buttonHeight,0,r);
    r.X:=buttonX+buttonWidth/2;
    csprite2d_Draw(txtMainTex,X+W+buttonWidth/2,Y,buttonWidth/2,buttonHeight,0,r);
    r.W:=1;
    csprite2d_Draw(txtMainTex,X+buttonWidth/2,Y,W,buttonHeight,0,r);
    if doCenter then
      guiDrawText(Text,X+buttonWidth/2+W/2,Y+textYOffset,align_center)
    else
      guiDrawText(Text,X+16,Y+textYOffset,align_left);
  end;

  procedure guiDrawMemoBorder(X,Y,W,H:single;Transparenty:Byte=255);
  begin
    X:=round(X); Y:=Round(Y);
    W:=round(W); H:=Round(H);
    r.X:=memoX; r.y:=memoY; r.W:=memoWidth; r.H:=memoHeight;
    csprite2d_Draw(txtMainTex,X,Y,memoWidth,memoHeight,0,r,Transparenty);
    r.X:=memoX+memoWidth;
    csprite2d_Draw(txtMainTex,X+W+memoWidth,Y,memoWidth,memoHeight,0,r,Transparenty);
    r.y:=memoY+memoHeight;
    csprite2d_Draw(txtMainTex,X+W+memoWidth,Y+H+memoHeight,memoWidth,memoHeight,0,r,Transparenty);
    r.X:=memoX; r.y:=memoY+memoHeight;
    csprite2d_Draw(txtMainTex,X,Y+H+memoHeight,memoWidth,memoHeight,0,r,Transparenty);
    r.X:=memoX+memoWidth; r.y:=memoY+memoHeight; r.W:=1;
    csprite2d_Draw(txtMainTex,X+memoWidth,Y+H+memoHeight,W,memoHeight,0,r,Transparenty);
    r.y:=memoY;
    csprite2d_Draw(txtMainTex,X+memoWidth,Y,W,memoHeight,0,r,Transparenty);
    r.X:=memoX; r.y:=memoY+memoHeight; r.W:=memoWidth; r.H:=1;
    csprite2d_Draw(txtMainTex,X,Y+memoHeight,memoWidth,H,0,r,Transparenty);
    r.X:=memoX+memoWidth;
    csprite2d_Draw(txtMainTex,X+W+memoWidth,Y+memoHeight,memoWidth,H,0,r,Transparenty);
    r.W:=1;
    csprite2d_Draw(txtMainTex,X+memoWidth,Y+memoHeight,W,H,0,r,Transparenty);
  end;

  procedure guiDrawForm(Text:string; X,Y,W,H:single;trans:Byte=255);
  begin
    W:=W-frmWidth*2;
    H:=H-frmHeight*2;
    r.X:=frmX; r.y:=frmY; r.W:=frmWidth; r.H:=frmHeight;
    csprite2d_Draw(txtMainTex,X,Y,frmWidth,frmHeight,0,r,trans);
    r.X:=frmX+frmWidth;
    csprite2d_Draw(txtMainTex,X+W+frmWidth,Y,frmWidth,frmHeight,0,r,trans);
    r.y:=frmY+frmHeight;
    csprite2d_Draw(txtMainTex,X+W+frmWidth,Y+H+frmHeight,frmWidth,frmHeight,0,r,trans);
    r.X:=frmX; r.y:=frmY+frmHeight;
    csprite2d_Draw(txtMainTex,X,Y+H+frmHeight,frmWidth,frmHeight,0,r,trans);
    r.X:=frmX+frmWidth; r.y:=frmY+frmHeight; r.W:=1;
    csprite2d_Draw(txtMainTex,X+frmWidth,Y+H+frmHeight,W,frmHeight,0,r,trans);
    r.y:=frmY;
    csprite2d_Draw(txtMainTex,X+frmWidth,Y,W,frmHeight,0,r,trans);
    r.X:=frmX; r.y:=frmY+frmHeight; r.W:=frmWidth; r.H:=1;
    csprite2d_Draw(txtMainTex,X,Y+frmHeight,frmWidth,H,0,r,trans);
    r.X:=frmX+frmWidth;
    csprite2d_Draw(txtMainTex,X+W+frmWidth,Y+frmHeight,frmWidth,H,0,r,trans);
    r.W:=1;
    csprite2d_Draw(txtMainTex,X+frmWidth,Y+frmHeight,W,H,0,r,trans);

    guiDrawText(Text,X+textXOffset+formXOffset,Y+formYOffset,align_left,False,trans);
  end;

end.
